# SpecTcl, by S. A. Uhler
# Copyright (c) 1994-1995 Sun Microsystems, Inc.
#
# See the file "license.txt" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
#
# interface generated from colors.ui
#   root     is the parent window for this user interface

proc colors_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
		set base ""
	} else {
		set base $root
	}
	
	frame $base.frame#2

	frame $base.color \
		-borderwidth 8

	label $base.red_l \
		-background white \
		-text red

	label $base.label#3 \
		-background white \
		-text green

	label $base.label#5 \
		-background white \
		-text blue

	scale $base.red \
		-bigincrement 0.0 \
		-command "try_color $base.red" \
		-from 255.0 \
		-resolution 1.0 \
		-showvalue 0 \
		-tickinterval -0.0 \
		-to 0.0 \
		-variable Red
	catch {
		$base.red configure \
			-font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
	}

	scale $base.green \
		-bigincrement 0.0 \
		-command "try_color $base.green" \
		-from 255.0 \
		-resolution 1.0 \
		-showvalue 0 \
		-tickinterval -0.0 \
		-to 0.0 \
		-variable Green
	catch {
		$base.green configure \
			-font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
	}

	scale $base.blue \
		-bigincrement 0.0 \
		-command "try_color $base.blue" \
		-from 255.0 \
		-resolution 1.0 \
		-showvalue 0 \
		-tickinterval -0.0 \
		-to 0.0 \
		-variable Blue
	catch {
		$base.blue configure \
			-font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
	}

	label $base.label#2 \
		-text 0 \
		-textvariable Red

	label $base.label#4 \
		-text 0 \
		-textvariable Green

	label $base.label#6 \
		-text 0 \
		-textvariable Blue

	button $base.button#1 \
		-command "lappend Colors \[format #%.2x%.2x%.2x \$Red \$Green \$Blue\]; destroy $root" \
		-padx 9 \
		-pady 3 \
		-text Add

	button $base.button#2 \
		-command "catch {eval \$Save_color}; destroy $root" \
		-padx 9 \
		-pady 3 \
		-text Cancel


	# Geometry management

	blt_table $root $base.frame#2 	4,1  \
		-columnspan 3
	blt_table $root $base.color 	1,1  \
		-columnspan 3
	blt_table $base.color $base.red_l 	1,1 
	blt_table $base.color $base.label#3 	1,2 
	blt_table $base.color $base.label#5 	1,3 
	blt_table $root $base.red 	2,1  \
		-fill y
	blt_table $root $base.green 	2,2  \
		-fill y
	blt_table $root $base.blue 	2,3  \
		-fill y
	blt_table $root $base.label#2 	3,1  \
		-fill both
	blt_table $root $base.label#4 	3,2  \
		-fill both
	blt_table $root $base.label#6 	3,3  \
		-fill both
	blt_table $base.frame#2 $base.button#1 	1,1 
	blt_table $base.frame#2 $base.button#2 	1,3 

	# Resize behavior management

	blt_table row $base.frame#2 configure all -resize none
	blt_table row $base.frame#2 configure 1 -height {30 Inf}
	blt_table column $base.frame#2 configure all -resize none
	blt_table column $base.frame#2 configure 2 -resize both
	blt_table column $base.frame#2 configure 1 -width {30 Inf}
	blt_table column $base.frame#2 configure 2 -width {5 Inf}
	blt_table column $base.frame#2 configure 3 -width {30 Inf}

	blt_table row $root configure all -resize none
	blt_table row $root configure 2 -resize both
	blt_table row $root configure 1 -height {30 Inf}
	blt_table row $root configure 2 -height {30 Inf}
	blt_table row $root configure 3 -height {30 Inf}
	blt_table row $root configure 4 -height {30 Inf}
	blt_table column $root configure all -resize none
	blt_table column $root configure 1 -width {30 Inf}
	blt_table column $root configure 2 -width {30 Inf}
	blt_table column $root configure 3 -width {30 Inf}

	blt_table row $base.color configure all -resize none
	blt_table row $base.color configure 1 -height {11 Inf}
	blt_table column $base.color configure all -resize none
	blt_table column $base.color configure 1 -width {20 Inf}
	blt_table column $base.color configure 2 -width {52 Inf}
	blt_table column $base.color configure 3 -width {30 Inf}
# additional interface code
catch {unset Save_color}

# end additional interface code

}
