# SpecTcl, by S. A. Uhler
# Copyright (c) 1994-1995 Sun Microsystems, Inc.
#
# See the file "license.txt" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
#
# interface generated from help.ui
#   root     is the parent window for this user interface

proc help_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
		set base ""
	} else {
		set base $root
	}
	
	frame $base.frame#1

	button $base.back \
		-command "HMlink_callback $base.text" \
		-padx 9 \
		-pady 3 \
		-text back

	button $base.button#2 \
		-command "HMset_state $base.text -stop 1; destroy $root" \
		-padx 9 \
		-pady 3 \
		-text dismiss

	label $base.file \
		-textvariable Help_file \
		-width 20

	scrollbar $base.scrollbar#1 \
		-command "$base.text yview" \
		-orient v

	text $base.text \
		-height 1 \
		-highlightthickness 0 \
		-width 1 \
		-xscrollcommand "$base.scrollbar#2 set" \
		-yscrollcommand "$base.scrollbar#1 set"
	catch {
		$base.text configure \
			-font -*-Courier-Medium-R-Normal--*-140-*-*-*-*-*-*
	}

	scrollbar $base.scrollbar#2 \
		-command "$base.text xview" \
		-orient h

	label $base.message \
		-textvariable Help_message


	# Geometry management

	blt_table $root $base.frame#1 	1,1  \
		-anchor w \
		-columnspan 2
	blt_table $base.frame#1 $base.back 	1,1 
	blt_table $base.frame#1 $base.button#2 	1,2 
	blt_table $base.frame#1 $base.file 	1,3 
	blt_table $root $base.scrollbar#1 	2,1  \
		-fill y
	blt_table $root $base.text 	2,2  \
		-fill both
	blt_table $root $base.scrollbar#2 	3,2  \
		-fill x
	blt_table $root $base.message 	4,1  \
		-columnspan 2

	# Resize behavior management

	blt_table row $root configure all -resize none
	blt_table row $root configure 2 -resize both
	blt_table row $root configure 1 -height {30 Inf}
	blt_table row $root configure 2 -height {442 Inf}
	blt_table row $root configure 3 -height {12 Inf}
	blt_table row $root configure 4 -height {15 Inf}
	blt_table column $root configure all -resize none
	blt_table column $root configure 2 -resize both
	blt_table column $root configure 1 -width {15 Inf}
	blt_table column $root configure 2 -width {523 Inf}

	blt_table row $base.frame#1 configure all -resize none
	blt_table row $base.frame#1 configure 1 -height {30 Inf}
	blt_table column $base.frame#1 configure all -resize none
	blt_table column $base.frame#1 configure 1 -width {26 Inf}
	blt_table column $base.frame#1 configure 2 -width {30 Inf}
	blt_table column $base.frame#1 configure 3 -width {30 Inf}
# additional interface code
global Fonts
catch {unset Fonts}

bind $base.text <space> {%W yview scroll 1 page;break}
bind $base.text <Home> {%W yview 0.0;break}
focus $base.text





# end additional interface code

}
