# SpecTcl, by S. A. Uhler
# Copyright (c) 1994-1995 Sun Microsystems, Inc.
#
# See the file "license.txt" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
#
# interface generated from spectcl.ui
#   root     is the parent window for this user interface

proc spectcl_ui {root args} {

	# this treats "." as a special case

	if {$root == "."} {
		set base ""
	} else {
		set base $root
	}
	
	frame $base.palette

	frame $base.toolbar

	frame $base.frame#7 \
		-borderwidth 2 \
		-relief sunken

	frame $base.buttons

	frame $base.menu

	canvas $base.can_column \
		-background white \
		-borderwidth 2 \
		-closeenough 1.0 \
		-height 0 \
		-highlightthickness 0 \
		-relief ridge \
		-width 0 \
		-xscrollincrement 10

	scrollbar $base.can_yscroll \
		-activerelief sunken \
		-command {can_view {.can .can_row} y} \
		-highlightthickness 0 \
		-orient v

	canvas $base.can_row \
		-background white \
		-borderwidth 2 \
		-closeenough 1.0 \
		-height 0 \
		-highlightthickness 0 \
		-relief ridge \
		-width 5 \
		-yscrollincrement 10

	canvas $base.can \
		-background #eee \
		-closeenough 1.0 \
		-height 0 \
		-width 0 \
		-xscrollcommand {.can_xscroll set} \
		-xscrollincrement 10 \
		-yscrollcommand {.can_yscroll set} \
		-yscrollincrement 10

	scrollbar $base.can_xscroll \
		-activerelief sunken \
		-borderwidth 3 \
		-command {can_view {.can .can_column} x} \
		-orient h

	label $base.message \
		-text {Click&drag for new widget, double-click for option sheet} \
		-textvariable _Message \
		-width 45
	catch {
		$base.message configure \
			-font -*-Helvetica-Medium-R-Normal--*-180-*-*-*-*-*-*
	}


	# Geometry management

	blt_table $root $base.palette 	3,1  \
		-fill y \
		-rowspan 3
	blt_table $root $base.toolbar 	2,1  \
		-columnspan 4 \
		-fill x
	blt_table $root $base.frame#7 	4,4  \
		-fill both
	blt_table $root $base.buttons 	6,1  \
		-columnspan 4 \
		-fill x
	blt_table $root $base.menu 	1,1  \
		-columnspan 4 \
		-fill x
	blt_table $root $base.can_column 	3,4  \
		-fill both
	blt_table $root $base.can_yscroll 	4,2  \
		-fill y
	blt_table $root $base.can_row 	4,3  \
		-fill both
	blt_table $base.frame#7 $base.can 	1,1  \
		-fill both
	blt_table $root $base.can_xscroll 	5,4  \
		-fill x
	blt_table $root $base.message 	7,1  \
		-columnspan 4 \
		-fill x

	# Resize behavior management

	blt_table row $base.frame#7 configure all -resize none
	blt_table row $base.frame#7 configure 1 -resize both
	blt_table row $base.frame#7 configure 1 -height {30 Inf}
	blt_table column $base.frame#7 configure all -resize none
	blt_table column $base.frame#7 configure 1 -resize both
	blt_table column $base.frame#7 configure 1 -width {1 Inf}

	blt_table row $root configure all -resize none
	blt_table row $root configure 4 -resize both
	blt_table row $root configure 1 -height {16 Inf}
	blt_table row $root configure 2 -height {5 Inf}
	blt_table row $root configure 3 -height {12 Inf}
	blt_table row $root configure 4 -height {282 Inf}
	blt_table row $root configure 5 -height {9 Inf}
	blt_table row $root configure 6 -height {8 Inf}
	blt_table row $root configure 7 -height {30 Inf}
	blt_table column $root configure all -resize none
	blt_table column $root configure 4 -resize both
	blt_table column $root configure 1 -width {30 Inf}
	blt_table column $root configure 2 -width {6 Inf}
	blt_table column $root configure 3 -width {12 Inf}
	blt_table column $root configure 4 -width {364 Inf}
# additional interface code
# avoid a layout bug in blt_table
blt_table column $root configure 3 -width 12
blt_table row    $root configure 3 -height 12




# end additional interface code

}
